Code:
Option Explicit' Deklarieren der Sleppfunktion, mit der zwischen den Rotationen kurze Pausen erzeugt werden
Public Declare PtrSafe Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As LongPtr) 'For 64-Bit versions of Excel
Private Const iWait As Integer = 200 ' Wartezeit in Millisekunden
Private Const iAngle As Integer = 30 ' Drehwinkel in Grad
Public Sub DemoStandardViews()
' Aufrufen aller vordefinierten Standardausrichtungen
Dim oApp As Inventor.Application
Set oApp = ThisApplication
Dim oDoc As Document
Set oDoc = oApp.ActiveDocument
If Not oDoc.DocumentType = kAssemblyDocumentObject And Not oDoc.DocumentType = kPartDocumentObject Then
Call MsgBox("Funktion nur in 3D-Modellen verfügbar", vbCritical, "Demo Kamerasteuerung")
Exit Sub
End If
Dim oView As View
Set oView = oApp.ActiveView
Dim oCam As Camera
Set oCam = oView.Camera
oCam.ViewOrientationType = kFrontViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
oCam.ViewOrientationType = kTopViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
oCam.ViewOrientationType = kRightViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
oCam.ViewOrientationType = kBackViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
oCam.ViewOrientationType = kLeftViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
oCam.ViewOrientationType = kIsoTopRightViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
oCam.ViewOrientationType = kIsoTopLeftViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
oCam.ViewOrientationType = kIsoBottomRightViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
oCam.ViewOrientationType = kIsoBottomLeftViewOrientation
oCam.Fit
oCam.Apply
Sleep (iWait)
' Aktivieren der Home-Ansicht
oView.GoHome
End Sub
Public Sub DemoViewZoom()
' die Änderung der Ansichtsgröße bewirkt einen Zoom
Dim oApp As Inventor.Application
Set oApp = ThisApplication
Dim oDoc As Document
Set oDoc = oApp.ActiveDocument
If Not oDoc.DocumentType = kAssemblyDocumentObject And Not oDoc.DocumentType = kPartDocumentObject Then
Call MsgBox("Funktion nur in 3D-Modellen verfügbar", vbCritical, "Demo Kamerasteuerung")
Exit Sub
End If
'Ermittlung der RangeBox
Dim oBox As Box
Set oBox = oDoc.ComponentDefinition.RangeBox
Dim dCenterX As Double
dCenterX = (oBox.MinPoint.X + oBox.MaxPoint.X) / 2
Dim dCenterY As Double
dCenterY = (oBox.MinPoint.Y + oBox.MaxPoint.Y) / 2
Dim dCenterZ As Double
dCenterZ = (oBox.MinPoint.Z + oBox.MaxPoint.Z) / 2
' Zentrum der RangeBox
Dim oCenterPoint As Point
Set oCenterPoint = oApp.TransientGeometry.CreatePoint(dCenterX, dCenterY, dCenterZ)
Dim oView As View
Set oView = oApp.ActiveView
Dim oCam As Camera
Set oCam = oView.Camera
' Zentrum der RangeBox als Drehzentrum
Dim oTarget As Point
Set oTarget = oCenterPoint
oCam.Apply
' die "Größe" der Ansicht/des Ansichtsfensters
' durch verändern wird gezoomt
Dim dViewHeight As Double
Dim dViewWidth As Double
Call oCam.GetExtents(dViewWidth, dViewHeight)
Call oCam.SetExtents(dViewWidth / 5, dViewHeight / 5)
oCam.Apply
Sleep (iWait)
Call oCam.SetExtents(dViewWidth * 2, dViewHeight * 2)
oCam.Apply
Sleep (iWait)
' Zoomen auf Größe der RangeBox
' liefert bei Ansichten, die nicht planparallel zur RangeBox liegen logischerweise wenig sinnvolles
Call oCam.SetExtents(oBox.MaxPoint.X - oBox.MinPoint.X, oBox.MaxPoint.Y - oBox.MinPoint.Y)
oCam.Apply
End Sub
Public Sub DemoViewPan()
' die parallele Änderung von KameraEye UND KameraTarget bewirkt einen Pan
' vereinfacht vorba Frontansicht aktivieren
Dim oApp As Inventor.Application
Set oApp = ThisApplication
Dim oDoc As Document
Set oDoc = oApp.ActiveDocument
If Not oDoc.DocumentType = kAssemblyDocumentObject And Not oDoc.DocumentType = kPartDocumentObject Then
Call MsgBox("Funktion nur in 3D-Modellen verfügbar", vbCritical, "Demo Kamerasteuerung")
Exit Sub
End If
Dim oTG As TransientGeometry
Set oTG = ThisApplication.TransientGeometry
Dim oView As View
Set oView = oApp.ActiveView
Dim oCam As Camera
Set oCam = oView.Camera
oCam.ViewOrientationType = kFrontViewOrientation
Dim dViewHeight As Double
Dim dViewWidth As Double
Call oCam.GetExtents(dViewWidth, dViewHeight)
Call oCam.SetExtents(dViewWidth * 1.5, dViewHeight * 1.5)
oCam.Apply
Dim oTarget As Point
Set oTarget = oCam.Target
Dim oEye As Point
Set oEye = oCam.Eye
Dim oVector As Vector
Set oVector = oTG.CreateVector(-10, 0, 0)
Call oEye.TranslateBy(oVector)
oCam.Eye = oEye
Call oTarget.TranslateBy(oVector)
oCam.Target = oTarget
oCam.Apply
Sleep (iWait)
oVector.X = 0
oVector.Y = 10
Call oEye.TranslateBy(oVector)
oCam.Eye = oEye
Call oTarget.TranslateBy(oVector)
oCam.Target = oTarget
oCam.Apply
Sleep (iWait)
oVector.X = 10
oVector.Y = 0
Call oEye.TranslateBy(oVector)
oCam.Eye = oEye
Call oTarget.TranslateBy(oVector)
oCam.Target = oTarget
oCam.Apply
Sleep (iWait)
oVector.X = 0
oVector.Y = -10
Call oEye.TranslateBy(oVector)
oCam.Eye = oEye
Call oTarget.TranslateBy(oVector)
oCam.Target = oTarget
oCam.Apply
Sleep (iWait)
End Sub
Public Sub DemoRotateCameraUpVector()
' Rotiert die Camera in Schritten um den aktuellen UpVector
Dim oApp As Inventor.Application
Set oApp = ThisApplication
Dim oDoc As Document
Set oDoc = oApp.ActiveDocument
If Not oDoc.DocumentType = kAssemblyDocumentObject And Not oDoc.DocumentType = kPartDocumentObject Then
Call MsgBox("Funktion nur in 3D-Modellen verfügbar", vbCritical, "Demo Kamerasteuerung")
Exit Sub
End If
Dim oTG As TransientGeometry
Set oTG = ThisApplication.TransientGeometry
Dim oView As View
Set oView = oApp.ActiveView
Dim oCam As Camera
Set oCam = oView.Camera
Dim iSteps As Integer
iSteps = 360 / iAngle
Dim oMatrix As Matrix
Set oMatrix = oTG.CreateMatrix
Call oMatrix.SetToRotation(iAngle * 3.14159 / 180, oCam.UpVector.AsVector, oCam.Target)
Dim oNewEye As Point
Set oNewEye = oCam.Eye
Dim i As Integer
For i = 1 To iSteps
Call oNewEye.TransformBy(oMatrix)
oCam.Eye = oNewEye
oCam.Apply '.ApplyWithoutTransition
Sleep (iWait)
Next
End Sub
Public Sub DemoRotateCameraXAxis()
' Rotiert die Camera in Schritten um die X-Achse
' Kamera rotieren funktioniert nur in der Front-/Rück/Oben- und Untenansicht
' für Rechts-/Linksansicht muss stattdessen der UpVector gedreht werden
' Unterscheidung durch ist-Parallel-Vergleich von Kamerasichtachse und X-Achse
' ISO-Ansichten und freie Position erzeugt Murks
Dim oApp As Inventor.Application
Set oApp = ThisApplication
Dim oDoc As Document
Set oDoc = oApp.ActiveDocument
If Not oDoc.DocumentType = kAssemblyDocumentObject And Not oDoc.DocumentType = kPartDocumentObject Then
Call MsgBox("Funktion nur in 3D-Modellen verfügbar", vbCritical, "Demo Kamerasteuerung")
Exit Sub
End If
Dim oTG As TransientGeometry
Set oTG = ThisApplication.TransientGeometry
Dim oView As View
Set oView = oApp.ActiveView
Dim oCam As Camera
Set oCam = oView.Camera
Dim iSteps As Integer
iSteps = 360 / iAngle
Dim oMatrix As Matrix
Set oMatrix = oTG.CreateMatrix
Dim oVector As Vector
'komplizierte Variante
'Set oVector = oDoc.ComponentDefinition.WorkAxes.Item(1).Definition.Axis.AsVector
'einfachere Variante Drehachse X
Set oVector = oTG.CreateVector(1, 0, 0)
' Drehachse Y
'Set oVector = oTG.CreateVector(0, 1, 0)
' Drehachse Z
'Set oVector = oTG.CreateVector(0, 0, 1)
Call oMatrix.SetToRotation(iAngle * 3.14159 / 180, oVector, oCam.Target)
Dim oNewEye As Point
Set oNewEye = oCam.Eye
Dim oNewUp As UnitVector
Set oNewUp = oCam.UpVector
Dim oVector2 As Vector
Set oVector2 = oCam.Eye.VectorTo(oCam.Target)
Dim i As Integer
For i = 1 To iSteps
If oVector.IsParallelTo(oVector2) Then
Call oNewUp.TransformBy(oMatrix)
oCam.UpVector = oNewUp
Else
Call oNewEye.TransformBy(oMatrix)
oCam.Eye = oNewEye
End If
oCam.Apply '.ApplyWithoutTransition
Sleep (iWait)
Next
End Sub
Public Sub DemoRotateCameraAxis()
' Rotiert die Camera in Schritten um die horizontale Achse
' rotieren um die Vertikalachse --> siehe rotieren um den Upvector ;-)
' Drehzentrum im Mittelpunkt
Dim oApp As Inventor.Application
Set oApp = ThisApplication
Dim oDoc As Document
Set oDoc = oApp.ActiveDocument
If Not oDoc.DocumentType = kAssemblyDocumentObject And Not oDoc.DocumentType = kPartDocumentObject Then
Call MsgBox("Funktion nur in 3D-Modellen verfügbar", vbCritical, "Demo Kamerasteuerung")
Exit Sub
End If
Dim oTG As TransientGeometry
Set oTG = ThisApplication.TransientGeometry
Dim oView As View
Set oView = oApp.ActiveView
Dim oCam As Camera
Set oCam = oView.Camera
' der Y-Vector ist die "Sichtlinie" vom Target zum Kameraauge
Dim oVectorY As Vector
Set oVectorY = oCam.Target.VectorTo(oCam.Eye)
' der Z-Vector ist der UpVector der Kamera
Dim oVectorZ As Vector
Set oVectorZ = oCam.UpVector.AsVector
Dim oMatrix As Matrix
Set oMatrix = oTG.CreateMatrix
Call oMatrix.SetToRotation(3.14159 / 2, oVectorY, oCam.Target)
' Erzeugen des X-Vektors als Kopie des Z-Vectors und drehen um 90°
Dim oVectorX As Vector
Set oVectorX = oVectorZ.Copy()
Call oVectorX.TransformBy(oMatrix)
Dim iSteps As Integer
iSteps = 360 / iAngle
' neue Werte für die Rotationsmatrix festlegen
Call oMatrix.SetToRotation(iAngle * 3.14159 / 180, oVectorX, oCam.Target)
Dim oNewEye As Point
Set oNewEye = oCam.Eye
Dim i As Integer
For i = 1 To iSteps
Call oNewEye.TransformBy(oMatrix)
oCam.Eye = oNewEye
oCam.Apply '.ApplyWithoutTransition
Sleep (iWait)
Next
End Sub